'--------------------------------------------------------------
'                    smartcard-codeslot
'
'                    (C) Johan thomas
'               E-Mail  johan@jthomas.myweb.nl
'--------------------------------------------------------------
'  File:       CARD_SLOT.BAS        Version 1.0
'  first:      5.6.2000
'  last:       7.6.2000  8.6.2000
'  controller: AT90S2313
'  schematic:  schema.jpg
'--------------------------------------------------------------
'                for non-comercial use free !
'--------------------------------------------------------------
'connect the hardware as shown in the schema.jpg file
'
'This smartcard_codelock can remember 2 different smartcards (telephone cards)
'if the cards are stored in the internal eeprom you can use the cards as keys.

Dim D As Byte , F As Byte , R As Byte , G As Byte , H As Byte , A As Byte

Config Pind.0 = Output
Config Pind.1 = Output
Config Pind.2 = Output
Config Pind.3 = Input
Config Pind.4 = Input
Config Pind.5 = Input
Config Pinb.1 = Output
Config Pind.6 = Input


I_o Alias Pind.5                                              'Input/Output Pin from Card
Clk Alias Portd.1                                             'Clock Pin from card
Rst Alias Portd.0                                             'reset pin from card
Power Alias Portd.2                                           'power for card
S1 Alias Pind.3                                               'switch in the card reader (NC)
1_2 Alias Pind.6                                              'jumper to choose card 1 or card 2


set portb.1                                                   'deactivate relais
Reset Rst                                                     'reset = 0
Reset Clk                                                     'clock = 0


Cls
Lcd " smartcard slot "
Lowerline
Lcd "   (c) D_J_T    "

Begin:
Wait 1
Reset Power                                                   'turn power for the card off(so there is no short-circuit when inserting the card)
Cls
Lcd " Please  insert "
Lowerline
Lcd "      card      "

Do
   If S1 = 1 Then                                             'wait till card is in the reader
      set power                                               'turn the power for the card on
      Waitms 50                                               'wait 50ms (so power is on before reading the card)
      Goto Start1
   End If
Loop



Start1:
                                                              '*reset card*
set rst                                                       'reset high
set clk                                                       'clock high
Waitus 50
Reset Rst                                                     'reset low
Reset Clk                                                     'clock low
Waitms 10                                                     'wait 10ms before reading the card

If 1_2 = 1 Then                                               'check which card has to be safed into the eeprom (card one or card two)
   A = 32
Else
   A = 0
End If

If Pind.4 = 0 Then                                            'check the jumper (if jumper closed then learn else check)
   Gosub Learn
Else
   Gosub Check
End If
End

Check:
For F = 0 To 31                                               'read 32 bits from the card
   D = 0
   For G = 0 To 7
      D = D * 2
      D = D + I_o
      set clk
      Waitus 10                                               'clock high
      Reset Clk
   Next G                                                     'clock low
   Readeeprom R , F                                           'read data from eeprom
   If D <> R Then Goto Other                                  'check if data from card is the same as in the eeprom
   Goto Cont

Other:
   H = F + 32
   Readeeprom R , H
   If D <> R Then Goto Error

Cont:
   Next F
Goto Ok
End


Learn:
Cls
Lcd "reading card"
Wait 1
For F = 0 To 31                                               'read the 32 bits from card
   D = 0
   For G = 0 To 7
      D = D * 2
      D = D + I_o
      set clk                                                 'clock high
      Waitus 10
      Reset Clk                                               'clock low
   Next G
   H = F + A
   Writeeeprom D , H                                          'write data to eeprom
Next F
Cls
Lcd "   card safed   "
Lowerline
Lcd "  remove  card  "
Do
   If S1 = 0 Then                                             'wait till card is removed
      Wait 1
      Goto Begin
   End If
Loop
End


Error:
Cls
Lcd "   fals card!   "
Lowerline
Lcd "  remove  card  "
Do
   If S1 = 0 Then                                             'wait till card is removed
      Waitms 100
      Goto Begin                                              'restart program
   End If
Loop
End


Ok:
Cls
Lcd "    card OK!    "
Lowerline
Lcd "  remove  card  "
Reset Portb.1                                                 'activate relais
Wait 5
set portb.1                                                   'deactivate relais
Do
   If S1 = 0 Then                                             'wait till card is removed
      Goto Begin                                              'restart program
   End If
Loop
End